	/*
	--------------------------------------------------------

		Donated (for 5 bucks) by Brad Perkins
		Intelligence Mfg Company
		3136 Redwood Ave
		West Sacramento, CA 95691
		

	Seriously, if you wish to donate $5, $10 or $15, you can
	bet I'll keep posting nifty do-dads that can be plugged into
	OV, Heck, I'll even take suggestions and critisism. If
	you dont wish to donate, well, thats OK too, but then I'll
	starve and wont be able to produce more OV do-hickys
	for you.  Read the up-front Glossary before going on please.
	
	
	
	
			/* GLOSSARY */

	API - Application Programming Interface:  The Windows API
	   is very similar to progamming to a DLL.  There are
	   standard function calls that require standard certain
	   argument types.  All windows supported lower level 
	   languages support the same windows API function calls.
	
	DLL - Dynamic Link Library
	
	   A DLL is very similar to any other standard windows 
	   program except that it usually provides a common set of
	   functions to  several programs.  That saves alot 
	   of space since needfull programs only need reference 
	   function names associated with the DLL.  For instance,
	   this DLL can be used by any number of windows programs
	   that need any one or more of the available functions.
	
	WIN- Short for Windows
	
	DDE - Dynamic Data Exchange:
            DDE is a messaging system that allows any number of
	    concurrently running programs to exchange data.
	    Remember a DLL is a library that contains functions
	    only.
		
	

			/* ANALYSIS */




	The Problem: OV does not provide everything I need!
	What is The solution for non-programmers ?
	
	
	Solution #1  Become a master programmer & write your own
	 	     DLLs. 

	I commented this code mostly for very beginning Win API
	programmers. It was obvious after following hundreds
	of threads on the Borland OV Forum,  the problems
	with linking to dlls from OV stemmed from a lack of 
	Programming experience on the part of the confused.  This
	seems natural since OV was produced with non-programmers
	in mind. It also became clear that once users experienced
	a little windows power using OV,  they desired more than
	OV offered internally.  I use PDC Prolog in my own programming 
	ventures with marvalous results.  The code is easy to read, 
	support is abundant and the compiler produces FAST/EFFICIENT 
	native code.  If you REALLY want to program, I highly 
	recommend this implementation 
	of Prolog. No I dont work for PDC but I have used
	PDC since it was called Turbo Prolog (Yep; A Borland
	Compiler!!).  The other Two most popular languages are
	C and C++, both which I find hard to read (and thus 
	maintain).   Check out my Prolog here; It is very
	modulized and requires much less code than C and runs
	just as fast in many cases (but is slightly bulkier
	EXE-wise)
	
	
	
	
	
	
	Solution #2 Be Frugal ("Toss pennies around like they're
	 manhole covers") 

	OV2 offers a reasonable DLL call interface and a somewhat 
	less reasonable DDE interface.	Most of of these limitations 
	can be overcome thanks to the 'open' nature of Windows.  
	For instance with certain programming tools you can find out 
	the names (handles) of OVs various windows.  Knowing the names 
	of the OV Objects allows you to capture messages, change 
	attributes about, alter those objects and thus contol to a 
	certain  degree what goes on in OV.  The Table-Field dialog 
	box is an example of a resource that becomes a "child" of 
	one of the main OV2 windows.  This makes it appear to
	be part of OV. 
	
	



	
	
	
	Solution #3 Keep makeing the big bucks
	(because master programmers don't make squat)
	
	
	So what can a Non-Programmer do?. I think, with very little 
	knowledge, you can at least connect OV to some existing 
	DLL libraries.  In a famous astronomers words;
	"There are Billions & Billions of those DLLs spread
	throughout the windows universe". In fact, your focused
	on one right now!  I've provided several function examples
	in this DODAD.DLL that I hope will assist you in understanding 
	what a function requires in the way of arguments and what 
	it returns.  Keep in mind that all OV2 functions accept 
	ONE return value (only).  Argument types are also important
	because DLL functions don't like it when you send them
	an INTEGER when they would rather have a STRING.  You'll
	need to learn simple argument types, values and how
	to order them.  OV Will NOT WORK with every DLL that
	comes down the pike at this time.  Some DLLs require
	up-front programming for creating complex structures and
	other things that the @REGISTER function cannot do.  This
	can be overcome if you are building a DLL specifically for 
	OV.  You can do all the complex "Where The Rubber Meets The
	Road" type work in your DLL and just return simple values
	back to OV.  This DODADS program's DDE and DIALOG BOX
	examples illustrate the problem well .Is this DLL designed
	to help you build your own DLLs?... No, just to show you
	whats involved in doing so at ever increasing complexity.
	This text does not even touch on Resource compilers, Export
	Librarys, .DEF files and many other "Need to know" details.
	And yet many of the lower level programming tools can
	insulate you from these details.  So programming windows
	at a lower level than OV does not have to be overwhelming.
	(Of course, assuming your already a DOS programmer).
	
	
	
	
			/*  DODADS.DLL Example */	
	
	
	
	Some simple (and not so simple) dll samples for OV2.  This 
	dll is written in PDC Prolog but should be comprehensible to 
	any experienced windows/c/pascal/.. programmer.  See the
	README file for instructions on registering and using
	functions in OV. Run the DODADS sample OV app to see swell 
	things happen.  The functions in the source below are 
	sequenced from simple to complex. If you're a beginning 	
	programmer in one of the Languages that support the Win API, 
	I encourage you to keep on keeping on, It does take some 
	time, but the rewards are satisfying (at least for me).  
	I've been 'windowed' for about a year and still consider myself 
	a beginning API programmer. But	learning is where much of 
	the fun is!!
	

			/* PDC Return Values (to OV)*/


	The last argument in a PDC function call is the RETURN 
	value to OV the GLOBAL PREDICATES declaration for each
	function more clearly represent return value positions..


	--------------------------------------------------------
	*/
	




	include "windows.dom"



	include "windows.con"
	include "windows.pre"
	include "c:\\prolog\\winbind\\ovibis\\paradox.pre"
	include "c:\\prolog\\winbind\\ovibis\\ovcall.pre"


	GLOBAL DOMAINS
	
	frequency,Duration = Integer


	% These declarations include all of the OV DLL @REGISTER
	% function calls (along with windows specific requirements)

	GLOBAL PREDICATES
	
  	WORD PrologLibMain(WORD,WORD,WORD,LPSTR) 


	/* OV Calls to PDC */
  						- (i,i,i,i) language pascal
  	BOOL ddeunadvise(String) 		- (i) language pascal
  	BOOL dderequest(String) 		- (i) language pascal
	determ BOOL OVsing(Frequency,Duration)  - (i,i) language pascal
	BOOL isdatafield(String,String) 	- (i,i) language pascal
	determ STRING ovsinglequote(string) 	- (i) language pascal
	determ STRING ovdoublequote(string) 	- (i) language pascal
	determ STRING OvConcat(String,String) 	- (i,i) language pascal

    	
	DATABASE - handles
  	
  	inst(HANDLE)              /* Instance handle */

	
	% This loads the window dialog box code for Data table fields
	% Look at the OVDIALOG.PRO file to see the windows API
	% functions for the dialog
    	
	include "c:\\prolog\\winbind\\ovibis\\ovdialog.pro"
  	
  	CLAUSES



	% Here's the DLL function code







	/*
	--------------------------------------------------
	
	OVSING - Play beautiful music (or some awful croaks!)
	       Plays a tone frequency of duration
	       If you use alot of these in a row in OV
	       EVENTS you may be able to make some nifty
	       noise.
  	OVRegister - 
  	@REGISTER("@SING","AII","Frequency,Duration","DODADS.DLL","sing",1)

  	Pred:	BOOL ovsing(Frequency,Duration)

  	Fail: Return No (never fails)

	Comment: To avoid confusion the Return value in PDC is 
	the last argument but the others are in correct order;
	The GLOBAL PREDICATES above shows the true ordering
	of returns an arguments to OV 
  	
  	---------------------------------------------------
  	*/

  	
  	
  	% Here's a REAL simple dll function that allows you to turn
  	% OV into another 'Twisted Sister' Rock-N-Roll band

  	
  	% If we compare the @REGISTER argument declaration "AII" to our actual
  	% function:
 	%      "I         I        A " it seems reversed but is identical 
  	ovsing(Frequency,Duration,b_true):-
  		sound(Duration,Frequency),!.  
  	ovsing(_,_,b_false).
  	


	









  	
  	
	/*
	-----------------------------------------------------------
	
	OVCONCAT - Return Concatenation of 2 Strings 
		
		

  	Pred:	String ovconcat(String1,String2)

  	Fail: Returns No (never fails)


  	OVREGISTER - 
  	@REGISTER("@CONCAT","CCC","InString,Concat","DODADS.DLL","ovconcat",1)

	Comment:
		this is a truely useful function that
		concatenates string #1 to #2 and returns
		the concated result. This is great for
		producing/filling text base fields.  
		Check out the demo; it's trick.  You can
		mix string text, field values, link values..
		It's great.  I'll bet this shows up sometime
		in a future version of OV
	  	
  	-----------------------------------------------------------
  	*/
  	

	
	ovConcat(InString,ConcatString,ResultString):-
		concat(InString,ConcatString,ResultString).

		% concat is built into the PDC compiler
		% so NO work is required
	
	
















	/*
	--------------------------------------------------
	
	OVDOUBLEQUOTE - Return double/single quoted string
		from an input string
		

	OV Register: First arg returns a double quoted string
	
			
  	@REGISTER("@DOUBLEQUOTE","CC","String","DODADS.DLL","ovdoublequote",1)

	OV Register: First arg returns a single quoted string
	
  	@REGISTER("@SINGLEQUOTE","CC","String","DODADS.DLL","ovsinglequote",1)

  	Pred: DoublequotedString ovdoubleQuote(String)
  	Pred: SinglequotedString ovsingleQuote(String)

  	Fail: Never fails

	Comment: These two functions could be done by
	  ovconcat but hey!, that's work, and I'm real 
	  lazy.

	  	
  	---------------------------------------------------
  	*/
	
	ovdoublequote(Instring,OutString):-
		concat("\"",Instring,Out1),  % Concat a " to the front
		concat(Out1,"\"",Outstring). % and to the back!
		
	ovsinglequote(Instring,OutString):-
		concat("'",Instring,Out1),  % Same as above but with '
		concat(Out1,"'",Outstring).
		











	/*
	--------------------------------------------------
	
	ISDATAFIELD - Return Yes if String is a name of a
		PARADOX table fieldname
		

	OV Register: First arg returns Yes or No
		Arg1 is a tablename; arg2 a fieldname
	
			
  	@REGISTER("@ISDATAFIELD","ACC",""TableName","FieldName"","DODADS.DLL","isdatafield",1)

  	Pred: BOOL IsDataField(String,String)

  	Fail: Returns No (Never fails)

	  	
  	---------------------------------------------------
  	*/


  	
  	
	isdatafield(TblName,FldName,b_true):-
		pXTblOpen(TblName,TableHandle,0,0),
		Success = PXFldHandle(TableHandle,FldName,_),
    		PXTblClose(TableHandle),
    		Success=0,!.
	isdatafield(_,_,b_false).

		
		
		
		






	/*
	---------------------------------------------------------
	
	O.K, You've seen the 'Cake' stuff, from here things
	get a bit more difficult.  We'll start with adding additional
	DDE support messages to OV.  Send_DDE_Message supports the 
	DDEUNADVISE and DDEREQUEST functions and are not called
	directly by OV
	
	---------------------------------------------------------
	*/
	

	  		


	% these functions just support the OV Callable DLL functions
	% that add two DDE messages; See ddeunadvise and dderequest
	% Below
    	

	DOMAINS
	
	MESS = unadvise;request  % the 2 messages we are adding

	PREDICATES
	
  	send_dde_message(MESS,HWND,ATOM)

	CLAUSES
	
	% post messages to all servers but not the client (OV2)

  	/* UNADVISE */

	send_dde_message(unadvise,Client,ItemAtom) :-
    		LParam = MAKELONG(0,ItemAtom),
		bitnot(Client,Servers),
    		Success = PostMessage(Servers,wm_dde_unadvise,Client,LParam),
    		Success<>0, !.
    		
	/* REQUEST */
	    		
	send_dde_message(request,Client,ItemAtom) :-
    		LParam = MAKELONG(cf_text,ItemAtom),
		bitnot(Client,Servers),
    		Success = PostMessage(Servers,wm_dde_request,Client,LParam),
    		Success<>0, !.

	/* DELETE ATOM ON FAILURE */

	send_dde_message(_,_,ItemAtom) :- !,
    		GlobalDeleteAtom(ItemAtom),
    		fail.





    
	/*
	---------------------------------------------------------
	
	SEND UNADVISE - Ends an advisory for current conversation 
			settings.  Posts unadvise message to server.


	OV Register: First arg returns Yes or No
	
  	@REGISTER("@DDEUNADVISE","AC","String","DODADS.DLL","ddeunadvise",1)
                    
  	Pred:	BOOL ddeunadvise(LinkName)


  	@REGISTER("@DDEREQUEST","AC","String","DODADS.DLL","dderequest",1)

  	Pred:   BOOL ddeRequest(Item)
                    

  	Fail: Returns No to OV else Yes (never fails)

	Comments: I found that these two DDE messages were required
	for some work I've been doing in ORACLE For Windows DDE
	Manager.  Although OV should maintain it's 'Easy' appeal, 
	these missing DDE messages should have been built into
	OV to begin with, as they are BASIC to a conventional DDE
	conversation.  I'll bet you 5 bucks they will appear like 
	magic in the next version of OV.

	
	---------------------------------------------------------
	*/
	

	CLAUSES

	ddeunadvise(LinkName,b_true) :-        % )
	
		% These API functions should demonstrate why some
		% complexities aren't and shouldn't be do'able in 
		% OV directly.  If OV could do all API functions
		% it wouldn't be distinguishable from any other
		% lower level language  
		
		NullWindowName = cast(String,0),
    		AItem = GlobalAddAtom(LinkName),
		Client  = findWindow("ObjectVisionDdeClass",NullWindowName),
    		send_dde_message(unadvise,Client,AItem),!.
	ddeunadvise(_,b_false).

	dderequest(Item,b_true) :-        % )
		NullWindowName = cast(String,0),
    		AItem = GlobalAddAtom(Item),
		Client  = findWindow("ObjectVisionDdeClass",NullWindowName),
    		send_dde_message(request,Client,AItem),!.
	dderequest(_,b_false).
		
		
		
		
		
		
	/*
	------------------------------------------------------------
	The last and most difficult of these examples is using a
	big chunk of actual windows API and Windows Resource type
	files.  The following function calls a windows resource
	called a dialog box.  For you beginners this means you must
	create a windows dialog resource file that will be compiled
	into your DLL.  The resource file contains information
	about drawing a window and placing buttons and other 
	controls into it and naming them.   The good news is that 
	Borland has the Resource Workshop program that makes creation 
	of these resource files very easy.  The hard part is linking the
	controls of the resource into your program and makeing them
	work for you.   Someone's got to do something about that, 
	because as I told you before, I'm very lazy. I'm not lazy 
	about working, just about doing things that are not necessary 
	or produce too little in too long.  The additional OVDIALOG.PRO 
	file contains the hideous Dialog Message Handling code.  But
	to be truthful, once the Win API is known, It's just a matter
	of knowing where to look in the SDK manuals, or some other
	book for help.
	
	For the MOST COMPLEX example; close your eyes; load OVDIALOG.PRO;
	and then look and be relieved that it's not all that bad.
	
	-------------------------------------------------------------
	*/
	
	
	
	
	% See the OVDIALOG.PRO File
		
		
		
		



	/*
	-------------------------------------------------------------
	
	The windows LIBMAIN function is required by every dll
	
	-------------------------------------------------------------
	*/
	
	


  	PrologLibMain(Instance,_,_,_,1):-
  		PxWinInit("dodads",pxshared),
  		assert(inst(Instance)).




	% Prolog Specific requirement for any executable file
	% Dont even worry about this (unless you like PDC Prolog)
	% By the way. PDC is an INCREDIBLE Programming language
	% Especially for beginning programmers!!!

	GOAL  beep.
  
